package com.company.bugy.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import java.math.BigDecimal;
import java.time.OffsetDateTime;
import java.util.UUID;

@JmixEntity
@Table(name = "BUGY_TEST_ENTITY")
@Entity(name = "bugy_TestEntity")
public class TestEntity {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    private OffsetDateTime createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    private OffsetDateTime lastModifiedDate;

    @Column(name = "Z01", length = 30)
    private String z01;

    @Column(name = "Z02", length = 30)
    private String z02;

    @Column(name = "Z03", length = 30)
    private String z03;

    @Column(name = "Z04", length = 30)
    private String z04;

    @Column(name = "Z05", length = 30)
    private String z05;

    @Column(name = "TOTAL", precision = 7, scale = 2)
    private BigDecimal total;

    public void setTotal(BigDecimal total) {
        this.total = total;
    }

    public BigDecimal getTotal() {
        return total;
    }

    public String getZ05() {
        return z05;
    }

    public void setZ05(String z05) {
        this.z05 = z05;
    }

    public String getZ04() {
        return z04;
    }

    public void setZ04(String z04) {
        this.z04 = z04;
    }

    public String getZ03() {
        return z03;
    }

    public void setZ03(String z03) {
        this.z03 = z03;
    }

    public String getZ02() {
        return z02;
    }

    public void setZ02(String z02) {
        this.z02 = z02;
    }

    public String getZ01() {
        return z01;
    }

    public void setZ01(String z01) {
        this.z01 = z01;
    }

    public OffsetDateTime getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(OffsetDateTime lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public OffsetDateTime getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(OffsetDateTime createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}